<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Statistics &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Threads" href="heiwa.views.thread.html" />
    <link rel="prev" title="Posts" href="heiwa.views.post.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="heiwa.views.html">API views</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.file.html">Files</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.forum.html">Forums</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.group.html">Groups</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.message.html">Messages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.post.html">Posts</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Statistics</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.thread.html">Threads</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.user.html">Users</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.utils.html">Utilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
          <li><a href="heiwa.views.html">API views</a> &raquo;</li>
      <li>Statistics</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.views.statistic.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.views.statistic">
<span id="statistics"></span><h1>Statistics<a class="headerlink" href="#module-heiwa.views.statistic" title="Permalink to this headline"></a></h1>
<p>API views for <a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic" title="heiwa.database.Statistic"><code class="xref py py-class docutils literal notranslate"><span class="pre">Statistic</span></code></a>s.</p>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.statistic.get_statistic">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.statistic.</span></span><span class="sig-name descname"><span class="pre">get_statistic</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic" title="heiwa.database.statistic.Statistic"><span class="pre">heiwa.database.statistic.Statistic</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/statistic.html#get_statistic"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.statistic.get_statistic" title="Permalink to this definition"></a></dt>
<dd><p>Gets the statistic with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <code class="xref py py-attr docutils literal notranslate"><span class="pre">id_</span></code> of the statistic
to find.</p></li>
<li><p><strong>session</strong> – The session to find the statistic with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the statistic. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIStatisticNotFound" title="heiwa.exceptions.APIStatisticNotFound"><strong>heiwa.exceptions.APIStatisticNotFound</strong></a> – Raised when the statistic
doesn’t exist, or the <code class="docutils literal notranslate"><span class="pre">user</span></code> does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The statistic.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.statistic.list_">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.statistic.</span></span><span class="sig-name descname"><span class="pre">list_</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/statistic.html#list_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.statistic.list_" title="Permalink to this definition"></a></dt>
<dd><p>Gets all statistic that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> has access to
view. If there is a filter requested, they must also match it.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of statistics, with the <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.statistic.view">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.statistic.</span></span><span class="sig-name descname"><span class="pre">view</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/statistic.html#view"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.statistic.view" title="Permalink to this definition"></a></dt>
<dd><p>Gets the statistics with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>, as long as the current
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> has the permission to view it.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic.id" title="heiwa.database.Statistic.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the statistic.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The statistic, with a HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.statistic.view_allowed_actions_instance">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.statistic.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_instance</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/statistic.html#view_allowed_actions_instance"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.statistic.view_allowed_actions_instance" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to
perform on the statistic with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic.id" title="heiwa.database.Statistic.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the statistic.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIStatisticNotFound" title="heiwa.exceptions.APIStatisticNotFound"><strong>heiwa.exceptions.APIStatisticNotFound</strong></a> – Raised when the statistic was
not found.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>A list of the allowed actions, with a <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><code class="xref py py-attr docutils literal notranslate"><span class="pre">heiwa.database.Statistic.instance_actions</span></code></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.statistic.view_allowed_actions_static">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.statistic.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_static</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/statistic.html#view_allowed_actions_static"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.statistic.view_allowed_actions_static" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to
perform of any statistic, without any knowledge on which one it will be.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with a <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.html#heiwa.database.Statistic.static_actions" title="heiwa.database.Statistic.static_actions"><code class="xref py py-attr docutils literal notranslate"><span class="pre">heiwa.database.Statistic.static_actions</span></code></a></p>
</div>
</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.views.post.html" class="btn btn-neutral float-left" title="Posts" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.views.thread.html" class="btn btn-neutral float-right" title="Threads" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>